import React from 'react';
import type { ViewProps } from 'react-native';
import type { FUNSDK_MEDIA_PLAY_STATE_ENUM } from '../types/stream';
export type MonitorViewNativeProps = ViewProps & {
    onMediaPlayState: (event: {
        nativeEvent: {
            state: FUNSDK_MEDIA_PLAY_STATE_ENUM | number;
        };
    }) => void;
    onShowRateAndTime: (event: {
        nativeEvent: {
            time: string;
            rate: string;
        };
    }) => void;
    onVideoBufferEnd: (event: {
        nativeEvent: {
            isBufferEnd: boolean;
        };
    }) => void;
    onFailed: (event: {
        nativeEvent: {
            msgId: number;
            errorId: number;
        };
    }) => void;
    onStartInit: (event: {
        nativeEvent: {};
    }) => void;
    onDebugState: (event: {
        nativeEvent: {
            state: string;
        };
    }) => void;
};
export declare const MonitorView: import("react-native").HostComponent<MonitorViewNativeProps>;
type MonitorProps = ViewProps & {
    devId: string;
    channelId: number;
    onStartInit?: () => void;
    onMediaPlayState?: (obj: {
        state: FUNSDK_MEDIA_PLAY_STATE_ENUM | number;
    }) => void;
    onShowRateAndTime?: (obj: {
        time: string;
        rate: string;
    }) => void;
    onVideoBufferEnd?: (obj: {
        isBufferEnd: boolean;
    }) => void;
    onFailed?: (obj: {
        msgId: number;
        errorId: number;
    }) => void;
    onDebugState?: (obj: {
        state: string;
    }) => void;
};
export declare class Monitor extends React.Component<MonitorProps, any> {
    private myRef;
    constructor(props: MonitorProps);
    playVideo(): void;
    pauseVideo(): void;
    replayVideo(): void;
    stopVideo(): void;
    destroyVideo(): void;
    getStreamType(): void;
    captureImage(path: string): void;
    startVideoRecord(path: string): void;
    stopVideoRecord(): void;
    openVoice(): void;
    closeVoice(): void;
    /**
     * set voice changer
     * 0 normal, 1 male ,2 female
     */
    startSingleIntercomAndSpeak(): void;
    stopSingleIntercomAndSpeak(): void;
    startDoubleIntercom(): void;
    stopDoubleIntercom(): void;
    switchStreamTypeMonitor(): void;
    setVideoFullScreen(isFullScreen: boolean): void;
    capturePicFromDevAndSave(): void;
    _onStartInit: () => void;
    _onMediaPlayState: (event: Parameters<MonitorViewNativeProps['onMediaPlayState']>[0]) => void;
    _onShowRateAndTime: (event: Parameters<MonitorViewNativeProps['onShowRateAndTime']>[0]) => void;
    _onVideoBufferEnd: (event: Parameters<MonitorViewNativeProps['onVideoBufferEnd']>[0]) => void;
    _onFailed: (event: {
        nativeEvent: {
            msgId: number;
            errorId: number;
        };
    }) => void;
    _onDebugState: (event: {
        nativeEvent: {
            state: string;
        };
    }) => void;
    render(): React.JSX.Element;
}
export {};
//# sourceMappingURL=index.d.ts.map