import { NativeEventEmitter, NativeModules } from 'react-native';

const funsdk = NativeModules.FunSDKDevQuickConnectModule;

export type StartSetWiFiParams = {
  passwordWifi: string;
  isDevDeleteFromOthersUsers: boolean;
};

/**
 * passwordWifi: string;
 * isDevDeleteFromOthersUsers: boolean;
 */
export function startSetWiFi(params: StartSetWiFiParams): void {
  return funsdk.startSetWiFi(params);
}

export function stopSetWiFi(): Promise<boolean> {
  return funsdk.stopSetWiFi();
}

export enum WiFiListenersEnum {
  ON_SET_WIFI = 'onSetWiFi',
  ON_ADD_DEVICE_STATUS = 'onAddDeviceStatus',
}

export type OnAddDeviceStatusType = {
  status: string | 'error' | 'start' | 'error-wifi';
  errorId: number | null;
  msgId: number | null;
};

export const wifiEventModule = funsdk;
export const wifiEventEmitter = new NativeEventEmitter(funsdk);

// listener example
// useEffect(() => {
//   const wifiEventEmitter = new NativeEventEmitter(wifiEventModule);
//   let eventListener = wifiEventEmitter.addListener(
//     WiFiListenersEnum.ON_SET_WIFI,
//     (event) => {
//       console.log('event: ', event); // "someValue"
//     }
//   );

//   // Removes the listener once unmounted
//   return () => {
//     eventListener.remove();
//   };
// }, []);
